private void solve(String line) {
    int lineLength = line.length();
    Map<Integer, ArrayList<Integer>> polygon = new HashMap<>();
    int currentX = 0; int currentY = 0;
    for(int i = 0; i < lineLength; i++){
        char operator = line.charAt(i);
        if(operator == 'U'){
            if(!polygon.containsKey(currentY)){
                ArrayList<Integer> temp = new ArrayList<Integer>();
                temp.add(currentX);
                polygon.put(currentY, temp);
            } else {
                ArrayList<Integer> temp = polygon.get(currentY);
                temp.add(currentX);
            }
            currentY++;
        } else if(operator == 'D'){
            currentY--;
            if(!polygon.containsKey(currentY)){
                ArrayList<Integer> temp = new ArrayList<Integer>();
                temp.add(currentX);
                polygon.put(currentY, temp);
            } else {
                ArrayList<Integer> temp = polygon.get(currentY);
                temp.add(currentX);
            }
        } else if(operator == 'R') { currentX++; }
        else if(operator == 'L') { currentX--; }
    }
    Iterator<Integer> allY = polygon.keySet().iterator();
    int nrBlocks = 0;
    while(allY.hasNext()){
        int yPos = allY.next();
        ArrayList<Integer> xValues = polygon.get(yPos);
        Collections.sort(xValues);
        for(int i=0; i<xValues.size()-1; i+=2){
            nrBlocks += xValues.get(i+1) - xValues.get(i);
        }
    }
    System.out.println(nrBlocks);
}
