static int[] parent;
static int[] rank;

static void solve(Scanner sc) throws Exception {
    int n = sc.nextInt();      // number of nodes
    int m = sc.nextInt(), s=0; // number of edges (in graph and in tree)
    Edge[] edges = new Edge[m];
    Edge[] tree = new Edge[n-1];
    for (int i = 0; i < m; i++)
        edges[i] = new Edge(sc.nextInt(), sc.nextInt(), sc.nextInt());
    parent = new int[n]; // disjoint-set
    rank = new int[n];   // datastructure
    for (int i = 0; i < n; i++) { parent[i] = i; }
    Arrays.sort(edges); 
    for (Edge e : edges) { if (join(e.x, e.y)) { tree[s++] = e; }}
    for (Edge e : tree)
        System.out.println("("+e.x+", "+e.y+", ["+e.l+"])");
}

static int find(int x) {
    return parent[x]==x ? x : (parent[x] = find(parent[x]));
}

static boolean join(int x, int y) { // false if x & y are in same set
    int xrt = find(x);
    int yrt = find(y);
    if (rank[xrt] > rank[yrt]) {
        parent[yrt] = xrt; 
    } else if (rank[xrt] < rank[yrt]) {
        parent[xrt] = yrt;
    } else if (xrt != yrt) {
        rank[parent[yrt]=xrt]++;
    }
    return xrt != yrt;
}

static class Edge implements Comparable<Edge> {
    int x, y, l; // from, to and length
    public Edge(int from, int to, int length){x=from; y=to; l=length;}
    public int compareTo(Edge e) {return l - e.l;}
}
