public int area(Rectangle[] rects) {
    int result = 0;
    for (int code = 1; code < (1 << rects.length); code++) {
        boolean used[] = decode(code, rects.length);
        int sign = -1;
        Rectangle intersected = new Rectangle(Integer.MIN_VALUE,
                Integer.MIN_VALUE, Integer.MAX_VALUE, Integer.MAX_VALUE);
        for (int i = 0; i < rects.length; i++) {
            if (used[i]) {
                intersected = Rectangle.intersect(intersected, rects[i]);
                if (intersected == null) { break; }
                sign = -sign;
            }
        }
        if (intersected != null) {
            result += sign * intersected.getArea();
        }
    }
    return result;
}
boolean[] decode(int code, int size) {
    boolean used[] = new boolean[size];
    for (int i = 0; i < used.length; i++) {
        used[i] = (code % 2 == 1);
        code /= 2;
    }
    return used;
}
class Rectangle {
    int minX, minY, int maxX, int maxY;
    public Rectangle(int minX, int minY, int maxX, int maxY) {
        this.minX=minX; this.minY=minY; this.maxX=maxX; this.maxY=maxY;
    }
    int getArea() { return (maxX - minX) * (maxY - minY); }
    static Rectangle intersect(Rectangle r1, Rectangle r2) {
        int iMinX = Math.max(r1.minX, r2.minX);
        int iMinY = Math.max(r1.minY, r2.minY);
        int iMaxX = Math.min(r1.maxX, r2.maxX);
        int iMaxY = Math.min(r1.maxY, r2.maxY);
        if (iMinX >= iMaxX || iMinY >= iMaxY) { return null; }
        else { return new Rectangle(iMinX, iMinY, iMaxX, iMaxY); }
    }
}
