public class Literal<T> {
    public final T value; 
    public final boolean isPos; 
    public Literal(T value, boolean isPos) {
        this.value = value; this.isPos = isPos;
    }
    public Literal<T> negation() { return new Literal<T>(value, !isPos); }
    public String toString() { return (isPos ? "" : "~") + value; }
    public boolean equals(Object obj) {
        if (!(obj instanceof Literal)) return false;
        Literal<?> realObj = (Literal) obj;
        return realObj.isPos == isPos && realObj.value.equals(value);
    }
    public int hashCode() {
        return (isPos ? 1 : 31) * value.hashCode();
    }
} 
