public int maxFlow() {
    int output = 0;
    while (true) {
        int pathCap = findPath();
        if (pathCap == 0) { break; }
        output += pathCap;
    }
    return output;
}
private int findPath() {
    Queue<Integer> q = new LinkedList<Integer>();
    boolean[] visited = new boolean[nrNodes + 2];
    int[] from = new int[nrNodes + 2];
    Arrays.fill(from, -1);
    q.add(0); visited[0] = true;
    while (!q.isEmpty()) {
        int cur = q.poll();
        List<Edge> adjc = graph.get(cur);
        if (cur == nrNodes + 1)
            break;
        for (Edge e : adjc) {
            if (!visited[e.b] && e.getCapacity() > 0) {
                q.add(e.b);
                visited[e.b] = true;
                from[e.b] = cur;
            }
        }
    }
    if (from[nrNodes + 1] == -1) { return 0; }
    int pathCap = Integer.MAX_VALUE;
    int cur = nrNodes + 1;
    while (from[cur] > -1) {
        int prev = from[cur];
        pathCap = Math.min(pathCap, getEdge(prev, cur).getCapacity());
        cur = prev;
    }
    cur = nrNodes + 1;
    while (from[cur] > -1) {
        int prev = from[cur];
        Edge e = getEdge(prev, cur);
        e.addFlow(pathCap);
        cur = prev;
    }
    return pathCap;
}
