class TreeIsomorphism { //ProblemE_ekp2003

    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int cases = in.nextInt();
        while (cases-- > 0) {
            char[] s = in.next().toCharArray();
            char[] t = in.next().toCharArray();
            Node[] t1 = new Node[s.length/2 + 1];
            Node[] t2 = new Node[t.length/2 + 1];
            makeTree(t1, s);
            makeTree(t2, t);
            if (isIsomorph(t1, t2)) System.out.println("same");
            else System.out.println("different");
        }
    }

    static boolean isIsomorph(Node[] s, Node[] t) {
        setRoot(s[0], s.length);
        for (int i = 0; i < t.length; i++)
            if (isomorph(s[0], setRoot(t[i], t.length))) return true;
        return false;
    }

    static boolean isomorph(Node n, Node m) {
        if (n.successors != m.successors || n.children.length != m.children.length)
            return false;
        if (n.successors == 0)
            return true;
        boolean found = true;
        boolean[] used = new boolean[m.children.length];
        for (int i = 0; i < n.children.length && found; i++) {
            if (n.children[i] == n.parent) continue;
            found = false;
            for (int j = 0; j < m.children.length && !found; j++) {
                if (used[j] || m.children[j] == m.parent) continue;
                used[j] = found = isomorph(n.children[i], m.children[j]);
            }
        }
        return found;
    }

    static void makeTree(Node[] tree, char[] s) {
        int size = 0;
        Node root = tree[size++] = new Node(null);
        for (int i = 0; i < s.length; i++)
            if (s[i] == '0') {
                tree[size] = new Node(root);
                root.childrenArray.add(tree[size]);
                root = tree[size++];
            } else {
                int successors = root.successors + 1;
                root.makeChildren();
                root = root.parent;
                root.successors += successors;
            }
        tree[0].makeChildren();
    }
    static Node setRoot(Node node, int n) {
        Node newParent = null;
        // walk up to the old root to set the new parent
        while (node != null) {
            Node next = node.parent;    node.parent = newParent;
            newParent = node;           node = next;
        }
        // walk back to the new root to set the number of successors
        node = newParent;
        while (node.parent != null) {
            node.successors = n - node.parent.successors - 2;
            node = node.parent;
        }
        node.successors = n - 1;
        return node;
    }
    static class Node {
        public ArrayList<Node> childrenArray = new ArrayList<Node>();
        public Node[] children; public Node parent;
        public int successors = 0;
        public Node(Node parent) {
            this.parent = parent; 
            if (parent != null) childrenArray.add(parent);
        }
        public void makeChildren() {
            children = new Node[childrenArray.size()];
            childrenArray.toArray(children);
            childrenArray = null;
        }
    }
}
